local safe_dofile = function( dir ) if io.file_is_readable( dir ) then dofile( dir ) else log( "[ERROR] PAYDAY 2 Tips Viewer - Cannot find directory: " .. dir ) end end 

_G.TipsViewer = _G.TipsViewer or {}

TipsViewer.ModPath = ModPath
TipsViewer.Menu = "TipsViewerMenu"

safe_dofile( TipsViewer.ModPath .. "menu.lua" )

local HookFiles = {
	[ "lib/managers/menu/menucomponentmanager" ] = "menucomponentmanager.lua"
}

Hooks:Add( "MenuManagerSetupCustomMenus" , "TipsViewerMenuManagerPostSetupCustomMenus" , function( self , nodes )

	MenuHelper:NewMenu( TipsViewer.Menu )

end )

Hooks:Add( "LocalizationManagerPostInit" , "TipsViewerLocalizationManagerPostInit" , function( self )

	self:load_localization_file( TipsViewer.ModPath .. "loc.txt" )

end )

Hooks:Add( "MenuManagerInitialize" , "TipsViewerMenuManagerPostInit" , function( self )

	MenuCallbackHandler.TipsViewerFocus = function( self , focus )
		if focus then
			TipsViewer:ShowTips()
		else
			TipsViewer:DestroyTips()
		end
	end

end )

Hooks:Add( "MenuManagerBuildCustomMenus" , "TipsViewerMenuManagerPostBuildCustomMenus" , function( self , nodes )
	
	nodes[ TipsViewer.Menu ] = MenuHelper:BuildMenu( TipsViewer.Menu , { focus_changed_callback = "TipsViewerFocus" } )
	MenuHelper:AddMenuItem( MenuHelper.menus.lua_mod_options_menu , TipsViewer.Menu , "tips_viewer_title" , "tips_viewer_desc" )

end )

Hooks:Add( "MenuManagerPopulateCustomMenus" , "TipsViewerMenuManagerPostPopulateCustomMenus" , function( self , nodes )

	if tweak_data and tweak_data.tips then
		local data = {}
		TipsViewer.Categories = {}
		TipsViewer.TipData = {}

		for k , v in pairs( tweak_data.tips.tips ) do
			if not data[ "loading_" .. v.category .. "_title" ] then
				data[ "loading_" .. v.category .. "_title" ] = true
				table.insert( TipsViewer.Categories , v.category )
			end

			TipsViewer.TipData[ v.category ] = TipsViewer.TipData[ v.category ] or {}
			TipsViewer.TipData[ v.category ][ v.cat_index ] = v.image
		end
	end

	MenuCallbackHandler[ "TipsViewerButtonCallback" ] = function( self ) end

	MenuHelper:AddButton({
		id 			= "TipsViewerButton",
		title 		= "",
		desc 		= "",
		callback 	= "TipsViewerButtonCallback",
		menu_id 	= TipsViewer.Menu,
		localized 	= false
	})

end )

if RequiredScript then

	local requiredScript = RequiredScript:lower()
	
	if HookFiles[ requiredScript ] then
		safe_dofile( TipsViewer.ModPath .. HookFiles[ requiredScript ] )
	end
	
end