local function aligntext( object , above )
	local _ , _ , _ , h = object:text_rect()

	object:set_h( h )
	object:set_right( TipsViewer._panel:right() - 8 )

	if above then object:set_top( above ) end
end

local function alignpage()
	local _ , _ , w , h = TipsViewer._page:text_rect()

	TipsViewer._page:set_size( w , h )
	TipsViewer._page:set_center_x( TipsViewer._category:center_x() )
	TipsViewer._page:set_top( TipsViewer._text:bottom() + 4 )

	TipsViewer._prev:set_righttop( TipsViewer._page:left() , TipsViewer._page:top() )
	TipsViewer._next:set_lefttop( TipsViewer._page:right() , TipsViewer._page:top() )
end

local function alignbg()
	TipsViewer._bg:set_righttop( TipsViewer._panel:right() , TipsViewer._category:top() - 1 )
	TipsViewer._bg_blur:set_righttop( TipsViewer._panel:right() , TipsViewer._category:top() - 1 )
	TipsViewer._bg:set_h( TipsViewer._page:bottom() - TipsViewer._category:top() )
	TipsViewer._bg_blur:set_h( TipsViewer._page:bottom() - TipsViewer._category:top() )
end

function TipsViewer:ShowTips()

	TipsViewer.CategoryIndex = TipsViewer.CategoryIndex or 1
	TipsViewer.PageIndex = TipsViewer.PageIndex or 1

	if not managers.menu_component then
		return
	end

	self._panel = managers.menu_component._ws:panel():panel()

	self._bg = self._panel:rect({
		w 		= self._panel:w() * 0.35,
		h 		= 0,
		color 	= tweak_data.screen_colors.button_stage_3,
		alpha 	= 0.25,
		layer 	= 500
	})

	self._bg_blur = self._panel:bitmap({
		texture 		= "guis/textures/test_blur_df",
		w 				= self._panel:w() * 0.35,
		h 				= 0,
		layer 			= 500,
		render_template = "VertexColorTexturedBlur3D"
	})

	self._category = self._panel:text({
		name 		= "category",
		text 		= managers.localization:to_upper_text( "loading_" .. TipsViewer.Categories[ TipsViewer.CategoryIndex ] .. "_title" ),
		blend_mode 	= "normal",
		w 			= ( self._panel:w() * 0.35 ) - 16,
		h 			= self._panel:h(),
		font 		= tweak_data.menu.pd2_large_font,
		font_size 	= 28,
		color 		= tweak_data.screen_colors.button_stage_2,
		vertical 	= "center",
		align 		= "center",
		wrap 		= true,
		word_wrap 	= true,
		layer 		= 501
	})

	self._text = self._panel:text({
		name 		= "text",
		text 		= managers.localization:text( "loading_" .. TipsViewer.Categories[ TipsViewer.CategoryIndex ] .. "_" .. TipsViewer.PageIndex ),
		blend_mode 	= "normal",
		w 			= ( self._panel:w() * 0.35 ) - 16,
		h 			= self._panel:h(),
		font 		= tweak_data.menu.pd2_large_font,
		font_size 	= 24,
		color 		= tweak_data.screen_colors.button_stage_2,
		vertical 	= "center",
		align 		= "center",
		wrap 		= true,
		word_wrap 	= true,
		layer 		= 501
	})

	self._page = self._panel:text({
		name 		= "page",
		text 		= string.format( "%d / %d" , TipsViewer.PageIndex , tweak_data.tips.category_totals[ TipsViewer.Categories[ TipsViewer.CategoryIndex ] ] ),
		blend_mode 	= "normal",
		w 			= self._panel:w() * 0.35,
		h 			= self._panel:h(),
		font 		= tweak_data.menu.pd2_large_font,
		font_size 	= 24,
		color 		= tweak_data.screen_colors.button_stage_3,
		vertical 	= "center",
		align 		= "center",
		layer 		= 501
	})

	self._cprev = self._panel:bitmap({
		texture 		= "guis/textures/menu_arrows",
		texture_rect 	= {
							0,
							0,
							24,
							24
						},
		color 			= tweak_data.screen_colors.button_stage_3,
		w 				= 24,
		h 				= 24,
		x 				= 0,
		y 				= 0,
		layer 			= 501,
		blend_mode 		= "normal"
	})

	self._cnext = self._panel:bitmap({
		texture 		= "guis/textures/menu_arrows",
		texture_rect 	= {
							24,
							0,
							-24,
							24
						},
		color 			= tweak_data.screen_colors.button_stage_3,
		w 				= 24,
		h 				= 24,
		x 				= 0,
		y 				= 0,
		layer 			= 501,
		blend_mode 		= "normal"
	})

	self._prev = self._panel:bitmap({
		texture 		= "guis/textures/menu_arrows",
		texture_rect 	= {
							0,
							0,
							24,
							24
						},
		color 			= tweak_data.screen_colors.button_stage_3,
		w 				= 24,
		h 				= 24,
		x 				= 0,
		y 				= 0,
		layer 			= 501,
		blend_mode 		= "normal"
	})

	self._next = self._panel:bitmap({
		texture 		= "guis/textures/menu_arrows",
		texture_rect 	= {
							24,
							0,
							-24,
							24
						},
		color 			= tweak_data.screen_colors.button_stage_3,
		w 				= 24,
		h 				= 24,
		x 				= 0,
		y 				= 0,
		layer 			= 501,
		blend_mode 		= "normal"
	})

	self._image = self._panel:bitmap({
		texture = "guis/textures/loading/hints/" .. TipsViewer.TipData[ TipsViewer.Categories[ TipsViewer.CategoryIndex ] ][ TipsViewer.PageIndex ],
		w 		= 192,
		h 		= 192,
		layer 	= 501
	})

	aligntext( self._category , self._panel:h() * .10 )

	self._image:set_top( self._category:bottom() )
	self._image:set_center_x( self._category:center_x() )

	aligntext( self._text , self._image:bottom() )

	self._cprev:set_lefttop( self._category:left() , self._category:top() )
	self._cnext:set_righttop( self._category:right() , self._category:top() )

	alignpage()

	alignbg()

end

function TipsViewer:DestroyTips()

	if alive( self._panel ) then

		self._panel:remove( self._category )
		self._panel:remove( self._text )
		self._panel:remove( self._page )
		self._panel:remove( self._bg )
		self._panel:remove( self._bg_blur )
		self._panel:remove( self._prev )
		self._panel:remove( self._next )
		self._panel:remove( self._cprev )
		self._panel:remove( self._cnext )
		self._panel:remove( self._image )
		self._panel:remove( self._panel )

		self._category = nil
		self._text = nil
		self._page = nil
		self._bg = nil
		self._bg_blur = nil
		self._prev = nil
		self._next = nil
		self._cprev = nil
		self._cnext = nil
		self._image = nil
		self._panel = nil

	end

end

function TipsViewer:SetCategoryIndex( index )

	if self.CategoryIndex + index < 1 then
		self.CategoryIndex = #TipsViewer.Categories
	elseif self.CategoryIndex + index > #TipsViewer.Categories then
		self.CategoryIndex = 1
	else
		self.CategoryIndex = self.CategoryIndex + index
	end

	self:SetPageIndex( 0 )

end

function TipsViewer:SetPageIndex( index )

	if self.PageIndex + index < 1 then
		self.PageIndex = tweak_data.tips.category_totals[ TipsViewer.Categories[ TipsViewer.CategoryIndex ] ]
	elseif self.PageIndex + index > tweak_data.tips.category_totals[ TipsViewer.Categories[ TipsViewer.CategoryIndex ] ] then
		self.PageIndex = 1
	else
		self.PageIndex = self.PageIndex + index
	end

	self:UpdateTips()

end

function TipsViewer:UpdateTips()

	if self._panel and alive( self._panel ) then
		self._category:set_text( managers.localization:to_upper_text( "loading_" .. TipsViewer.Categories[ TipsViewer.CategoryIndex ] .. "_title" ) )
		self._text:set_text( managers.localization:text( "loading_" .. TipsViewer.Categories[ TipsViewer.CategoryIndex ] .. "_" .. TipsViewer.PageIndex ) )
		self._page:set_text( string.format( "%d / %d" , TipsViewer.PageIndex , tweak_data.tips.category_totals[ TipsViewer.Categories[ TipsViewer.CategoryIndex ] ] ) )

		self._image:set_image( "guis/textures/loading/hints/" .. TipsViewer.TipData[ TipsViewer.Categories[ TipsViewer.CategoryIndex ] ][ TipsViewer.PageIndex ] )

		aligntext( self._text , self._image:bottom() )
		alignpage()
		alignbg()
	end

end